const c = canvas.getContext('2d');
const gridSize = 30;
const n = gridSize;
const m = gridSize;
const margin = 10;
const timeIncrement = 0.0002;

let time = 4.3;
let w = canvas.width;
let h = canvas.height;
let xOffset = 0;
let yOffset = 0;

function redraw() {
  updateSizeIfNecessary();

  c.fillStyle = 'rgba(0,0,0,0.05)';
  c.fillRect(0, 0, canvas.width, canvas.height);
  for (let i = 0; i < n; i++) {
    for (let j = 0; j < n; j++) {
      const u = i / (n - 1);
      const v = j / (m - 1);
      const theta = u * Math.PI * 2 + j;
      const speed =
        30 + (Math.sin(time) / 2 + 0.5) * 3;
      const r =
        v - 0.2 + Math.sin(time * speed) * 0.5;

      const x =
        (Math.sin(theta + time * i) * r * w) / 2 +
        w / 2;
      const y =
        (Math.cos(theta + time * i) * r * h) / 2 +
        h / 2;

      const q = 8 + Math.sin(time * 80) * 2;
      const radius =
        ((Math.sin(i + time * 800) + 1) *
          (n - j)) /
        q;

      c.fillStyle = rgb(
        (Math.sin(j / 4 - time * 200) / 2 + 0.5) *
          255,
        (Math.sin(j / 3 - time * 200) / 2 + 0.5) *
          255,
        (Math.sin(j / 5 - time * 200) / 2 + 0.5) *
          100
      );

      drawCircle(
        x + xOffset,
        y + yOffset,
        radius
      );
    }
  }

  time += timeIncrement;

  requestAnimationFrame(redraw);
}

function updateSizeIfNecessary() {
  if (
    canvas.width != window.innerWidth ||
    canvas.height != window.innerHeight
  ) {
    canvas.width = window.innerWidth;
    canvas.height = window.innerHeight;
    size = (canvas.width + canvas.height) / 2;
    w = size;
    h = size;

    xOffset = (canvas.width - size) / 2;
    yOffset = (canvas.height - size) / 2;
  }
}

function drawCircle(x, y, radius, arcAngle) {
  arcAngle = arcAngle || Math.PI * 2;
  c.beginPath();
  c.arc(x, y, radius, 0, arcAngle);
  c.closePath();
  c.fill();
}
function rgb(r, g, b) {
  r = Math.floor(r);
  g = Math.floor(g);
  b = Math.floor(b);
  return ['rgb(', r, ',', g, ',', b, ')'].join(
    ''
  );
}

redraw();
